# DepLing2021 Number Agreement

Kaius Sinnemäki & Akira Takaki, University of Helsinki

***

This repository contains the supplementary data for the following article; please cite it when using the data:

Sinnemäki, Kaius & Akira Takaki 2021. Number agreement, dependency length, and word order in Finnish traditional dialects. In *Proceedings of the Sixth International Conference on Dependency Linguistics (Depling, SyntaxFest 2021)*. Stroudsburg, PA: The Association for Computational Linguistics.

This repository has been created by Kaius Sinnemäki. The data has been automatically retrived from the Language Bank of Finland by Viljami Haakana, and analyzed manually by Akira Takaki and Kaius Sinnemäki.


***

## Contents

### [Data](https://version.helsinki.fi/gramadapt/depling2021-number-agreement/-/tree/main/Data)

The file **`data.csv`** is a tab-separated csv-file containing the analyzed data. The following keys explain the column names:
- **`lemma.noun`** = lemma of the subject noun, as in the original data (a few corrected)
- **`lemma.Vfin`** = lemma of the finite auxiliary verb
- **`lemma.Vlex`** = lemma of the main lexical verb
- **`agreement.Vfin`** = number agreement on the finite auxiliary verb (possible values: "singular" and "plural")
- **`agreement.Vlex`** = number agreement on the main lexical verb (possible values: "singular" and "plural")
- **`order.Vfin`** = word order of the subject and the finite auxiliary verb
- **`order.Vlex`** = word order of the subject and the main lexical verb
- **`distance.Vfin`** = dependency length, between the subject and the finite auxiliary verb (zero = adjacency)
- **`distance.Vlex`** = dependency length, between the subject and the main lexical verb (zero = adjacency)
- **`town`** = town of residence of the interviewee
- **`dialect.group`** = dialect group of the interviewee
- **`dialect.area`** = dialect area of the interviewee
- **`year.birth`** = year of birth of the interviewee
- **`age`** = age of the interviewee (in years)
- **`gender`** = gender of the interviewee
- **`interviewee`** = a unique random identifier for each interviewee
- **`data`** = retrieved clause in which the subject-verb dependency occurs
- **`context.prior`** = context prior to the lexical subject in the clause
- **`subject`** = lexical subject in its surface form in the clause
- **`context.following`** = context following the lexical subject in the clause

The original dialect corpus data can be accessed from the Language Bank of Finland from the following address: [http://urn.fi/urn:nbn:fi:lb-2019092002](http://urn.fi/urn:nbn:fi:lb-2019092002)


### [Scripts](https://version.helsinki.fi/gramadapt/depling2021-number-agreement/-/tree/main/Scripts)

This directory contains Python scripts that were used for retriving the data from the original corpus as well as an R script for the statistical modelling and graphs.


***

This research has received funding from the European Research Council (ERC) under the European Union’s Horizon 2020 research and innovation programme (grant agreement No 805371).
