from collections import defaultdict
from collections import deque
import os
from csv_functions import avaa, write_table
from md5Hash import md5hash as md5

orig_folder = os.getcwd()

MAXSANVAL = 4 # maximum number of words+pauses in between
MAXDEPLENGTH = 4

save_as = 'substantiividataLiittopredikaatitJulk.tsv'


os.chdir('korpus/LA-murre-vrt') # location of .vrt files



sukupuolet = defaultdict(lambda: '⚪')
#sukupuolet = {'male': '♂', 'female': '♀', None: '⚪'}
sukupuolet['male'] = '♂'
sukupuolet['female'] = '♀'

tiedostot = sorted([w for w in os.listdir() if w.endswith('.vrt')])

def containsalpha(s):
    return any(char.isalpha() for char in s)

def laske_ika(pvm1, pvm2):
    try:
        paiva1, kuukausi1, vuosi1 = [int(i) for i in pvm1.split('.')]
        paiva2, kuukausi2, vuosi2 = [int(i) for i in pvm2.split('.')]

        ika = vuosi2-vuosi1

        if kuukausi1 > kuukausi2:
            ika -= 1
        elif kuukausi1 == kuukausi2 and paiva1 > paiva2:
            ika -= 1

        return ika
    except:
        return None

def etsi_tapaukset(tied_nimi):
    vrt_data = avaa(tied_nimi)
    rivit = vrt_data.splitlines()
    rivit.append('')
    
    vastaus = [['lnum', 'subst_l', 'subst_sm', 'kongr1', 'kongr2', 'kongr3', 'ed_konteksti', 'pred', 'toka', 'kolmas', 'seur_konteksti', 'et.subst.fin', 'et.subst.toka', 'et.subst.kolmas', 'verbi_lemma', 'fin_lemma', 'fin_tempus', 'fin_modus', 'morf', 'pitäjä', 'murreryhmä', 'murrealue', 'synt.aika', 'pvm', 'ikä', 'sp']]


    pit = None #parish (pitäjä)
    mr = None #dialect group (murreryhmä)
    ma = None #dialect region (murrealue)
    saik = None #birthdate
    pvm = None #date of recording
    ik = None #age
    sp = None #sex

    lid = None

    haast = False

    metadata_found = 0

    for n, line in enumerate(rivit[:-1]):
        if line.startswith('<text info='):
            if 'Äänitetty' in line:
                lstcheck = line[line.index('Äänitetty'):].split()
                for item in lstcheck:
                    rstripdot = item.rstrip('.')
                    if all(c.isdigit() or c == '.' for c in rstripdot):
                        pvm = rstripdot
                        metadata_found += 1
                        break
            if 'parish=' in line:
                pit = line[line.index('parish=')+8:].split('"')[0]
                metadata_found += 1
            if 'dialect_group=' in line:
                mr = line[line.index('dialect_group=')+15:].split('"')[0]
                metadata_found += 1
            if 'dialect_region=' in line:
                ma = line[line.index('dialect_region=')+16:].split('"')[0]
                metadata_found += 1

        if line.startswith('<'):
            if 'speaker_role=' in line and 'speaker_role="Speaker"' not in line: #lam_asko rivi 9489 alkaa <paragraph speaker_sex="" speaker_role=""
                haast = True
                continue
            elif 'speaker_role="Speaker"' in line:
                assert 'speaker_role="Interviewer"' not in line
                haast = False

            if 'speaker_birthdate=' in line:
                saik2 = '.'.join(line[line.index('speaker_birthdate=')+19:].split('"')[0].split('-')[::-1])
                if saik is None:
                    metadata_found += 1
                saik = saik2

            if 'speaker_age=' in line:
                ik2 = '.'.join(line[line.index('speaker_age=')+13:].split('"')[0].split('-')[::-1])

                if ik is None:
                    metadata_found += 1
                ik = ik2

            
            if 'speaker_sex=' in line:

                sp2 = sukupuolet[line[line.index('speaker_sex='):].split('=')[1].split()[0].strip('"')]
                
                if sp is None:
                    metadata_found += 1
                sp = sp2
            if line.startswith('<sentence') and not haast:
                try:
                    lid = line[line.rindex(' id=')+5:].split('"')[0]
                except:
                    lid = 'tuntematon' #unknown

                if not metadata_found >= 6:
                    print(n, line, tied_nimi, 'does not contain all metadata in expected places')
                    print(ik)
                    print(metadata_found, pit, mr, saik, pvm, sp)
                    metadata_found = 5
                    if ik is None:
                        ik = laske_ika(saik, pvm)
                
        elif not haast:
            
            solut = line.split('\t')
            seur_solut = rivit[n+1].split('\t')
            if not seur_solut or seur_solut[0].startswith('<'):
                continue
            ed_konteksti = deque()
            seur_konteksti = [seur_solut]

            m = n-1
            o = n+2

            while m >= 0 and not rivit[m].startswith('<'):
                ed_konteksti.appendleft(rivit[m].split('\t'))
                m -= 1

                


            try:

                while not rivit[o].startswith('<'):
                    seur_konteksti.append(rivit[o].split('\t'))
                    #print(rivit[o].startswith('<'), rivit[o])
                    o += 1

            except IndexError:
                #print(seur_konteksti)
                pass

            contains_multiword_pred = 0

            for line in list(ed_konteksti) + list(seur_konteksti):
                if line[5] == 'pred3':
                    contains_multiword_pred = 3
                    break
                elif line[5] == 'pred2' and contains_multiword_pred < 3:
                    contains_multiword_pred = 2

            #print(len(seur_konteksti))

# 0 lnum: sentence number
# 1 subst_l: lemma of subject
# 2 subst_sm: word form of subject
# 3 kongr1: finite verb agreement
# 4 kongr2: second part agreement
# 5 kongr3: third part agreement
# 6 ed_konteksti: previous context
# 7 pred: finite verb
# 8 toka: second part of predicate
# 9 kolmas: third part of predicate
# 10 seur_konteksti: following context
# 11 et.subst.fin: distance between noun and finite verb (0 = immediately after, 1 = after next word, -1 = immediately before)
# 12 et.subst.toka: distance betwee noun and second part of predicate
# 13 et.subst.kolmas: distance betwee noun and third part of predicate
# 14 verbi_lemma: lemma of last part of predicate
# 15 fin_lemma: lemma of finite verb
# 16 fin_tempus: tense of finite verb
# 17 fin_modus: mood of finite verb
# 18 morf: morphological analyses
# 19 pitäjä: parish
# 20 murreryhmä: dialect group
# 21 murrealue: dialect region
# 22 synt.aika: speaker's birthdate
# 23 pvm: date of recording
# 24 ikä: speaker's age
# 25 sp: speaker's sex (♂/♀/⚪)
            vseur_rivi=[lid,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,pit,mr,ma,saik,pvm,ik,sp]
            if contains_multiword_pred == 2: # indices 5, 9 and 13 stay empty
                if solut[3] == 'n' and 'pl nom' in solut[4] and solut[5] == 'npsubj':
                    vseur_rivi[1] = solut[2] # lemma of noun
                    vseur_rivi[2] = solut[1] # word form of noun

                    morf_kuvaukset = [solut[4], None, None]

                    taukoja = 0

                    for n, line in enumerate(ed_konteksti):
                        if not containsalpha(line[2]): # pause -> do not count in distances
                            taukoja += 1
                        if line[5] == 'pred2':
                            if 'sg' in line[4]:
                                vseur_rivi[4] = 'sg'
                            elif 'pl' in line[4]:
                                vseur_rivi[4] = 'pl'
                            vseur_rivi[12] = n-len(ed_konteksti) + taukoja # distance
                            vseur_rivi[14] = line[2]
                            morf_kuvaukset[2] = line[4]
                            vseur_rivi[8] = line[1]
                        if line[5] == 'pred:toisto' or line[5] == 'pred':
                            pred_toisto = True
                            if 'sg' in line[4]:
                                vseur_rivi[3] = 'sg'
                            elif 'pl' in line[4]:
                                vseur_rivi[3] = 'pl'
                            vseur_rivi[11] = n-len(ed_konteksti) + taukoja
                            vseur_rivi[14] = line[2]
                            morf_kuvaukset[1] = line[4]
                            vseur_rivi[7] = line[1]
                            vseur_rivi[15] = line[2]

                    taukoja = 0

                    pred2j = False
                    predj = False

                    for n, line in enumerate(seur_konteksti):
                        if not containsalpha(line[2]): # pause -> do not count this word in distances
                            taukoja += 1
                        if line[5] == 'pred2' and not pred2j:
                            if 'sg' in line[4]:
                                vseur_rivi[4] = 'sg'
                            elif 'pl' in line[4]:
                                vseur_rivi[4] = 'pl'
                            vseur_rivi[12] = n - taukoja # distance
                            vseur_rivi[14] = line[2]
                            morf_kuvaukset[2] = line[4]
                            vseur_rivi[8] = line[1]
                            pred2j = True
                        if (line[5] == 'pred:toisto' or line[5] == 'pred') and not predj:
                            pred_toisto = True
                            if 'sg' in line[4]:
                                vseur_rivi[3] = 'sg'
                            elif 'pl' in line[4]:
                                vseur_rivi[3] = 'pl'
                            vseur_rivi[11] = n - taukoja
                            vseur_rivi[14] = line[2]
                            morf_kuvaukset[1] = line[4]
                            vseur_rivi[7] = line[1]
                            vseur_rivi[15] = line[2]
                            predj = False


                    vseur_rivi[6] = ' '.join(line[1] for line in ed_konteksti)
                    vseur_rivi[10] = ' '.join(line[1] for line in seur_konteksti)
                    vseur_rivi[18] = tuple(morf_kuvaukset)

                    fin_morf_kuv = str(morf_kuvaukset[1]).split()

                    if fin_morf_kuv[0] == 'fin':
                        if fin_morf_kuv[1] == 'ind':
                            vseur_rivi[17] = fin_morf_kuv[1] # eg. 'fin ind pres sg3'.split()[1] is the mood (...).split()[2] is the tense
                            vseur_rivi[16] = fin_morf_kuv[2]
                        else:
                            vseur_rivi[17] = fin_morf_kuv[1] # eg. 'fin cond sg3'.split()[1] is the mood and the tense will stay None
                            vseur_rivi[16] = fin_morf_kuv[2] if fin_morf_kuv[2].isalpha() else None
                            if fin_morf_kuv[2].isalpha(): print(fin_morf_kuv)

                    vastaus.append(vseur_rivi)

# 0 lnum: sentence number
# 1 subst_l: lemma of subject
# 2 subst_sm: word form of subject
# 3 kongr1: finite verb agreement
# 4 kongr2: second part agreement
# 5 kongr3: third part agreement
# 6 ed_konteksti: previous context
# 7 pred: finite verb
# 8 toka: second part of predicate
# 9 kolmas: third part of predicate
# 10 seur_konteksti: following context
# 11 et.subst.fin: distance between noun and finite verb (0 = immediately after, 1 = after next word, -1 = immediately before)
# 12 et.subst.toka: distance betwee noun and second part of predicate
# 13 et.subst.kolmas: distance betwee noun and third part of predicate
# 14 verbi_lemma: lemma of last part of predicate
# 15 fin_lemma: lemma of finite verb
# 16 fin_tempus: tense of finite verb
# 17 fin_modus: mood of finite verb
# 18 morf: morphological analyses
# 19 pitäjä: parish
# 20 murreryhmä: dialect group
# 21 murrealue: dialect region
# 22 synt.aika: speaker's birthdate
# 23 pvm: date of recording
# 24 ikä: speaker's age
# 25 sp: speaker's sex (♂/♀/⚪)

            if contains_multiword_pred == 3:

                if solut[3] == 'n' and 'pl nom' in solut[4] and solut[5] == 'npsubj':
                    vseur_rivi[1] = solut[2] # lemma of noun
                    vseur_rivi[2] = solut[1] # word form of noun

                    morf_kuvaukset = [solut[4], None, None, None]

                    taukoja = 0

                    for n, line in enumerate(ed_konteksti):
                        if not containsalpha(line[2]): # pause -> do not count this in distances
                            taukoja += 1
                        if line[5] == 'pred3':
                            if 'sg' in line[4]:
                                vseur_rivi[5] = 'sg'
                            elif 'pl' in line[4]:
                                vseur_rivi[5] = 'pl'
                            vseur_rivi[13] = n-len(ed_konteksti) + taukoja #distance
                            vseur_rivi[14] = line[2]
                            morf_kuvaukset[3] = line[4]
                            vseur_rivi[9] = line[1]
                        if line[5] == 'pred2':
                            if 'sg' in line[4]:
                                vseur_rivi[4] = 'sg'
                            elif 'pl' in line[4]:
                                vseur_rivi[4] = 'pl'
                            vseur_rivi[12] = n-len(ed_konteksti) + taukoja #distance
                            morf_kuvaukset[2] = line[4]
                            vseur_rivi[8] = line[1]
                        if line[5] == 'pred:toisto' or line[5] == 'pred':
                            pred_toisto = True
                            if 'sg' in line[4]:
                                vseur_rivi[3] = 'sg'
                            elif 'pl' in line[4]:
                                vseur_rivi[3] = 'pl'
                            vseur_rivi[11] = n-len(ed_konteksti) + taukoja
                            vseur_rivi[14] = line[2]
                            morf_kuvaukset[1] = line[4]
                            vseur_rivi[7] = line[1]
                            vseur_rivi[15] = line[2]

                    taukoja = 0

                    pred3j = False
                    pred2j = False
                    predj = False

                    for n, line in enumerate(seur_konteksti):
                        if not containsalpha(line[2]): # pause -> do not count this in distances
                            taukoja += 1
                        if line[5] == 'pred3' and not pred3j:
                            if 'sg' in line[4]:
                                vseur_rivi[5] = 'sg'
                            elif 'pl' in line[4]:
                                vseur_rivi[5] = 'pl'
                            vseur_rivi[13] = n - taukoja #distance
                            vseur_rivi[14] = line[2]
                            morf_kuvaukset[3] = line[4]
                            vseur_rivi[9] = line[1]
                            pred3j = True
                        if line[5] == 'pred2' and not pred2j:
                            if 'sg' in line[4]:
                                vseur_rivi[4] = 'sg'
                            elif 'pl' in line[4]:
                                vseur_rivi[4] = 'pl'
                            vseur_rivi[12] = n - taukoja #distance
                            #vseur_rivi[14] = line[2] # not this, but pred3
                            morf_kuvaukset[2] = line[4]
                            vseur_rivi[8] = line[1]
                            pred2j = True
                        if (line[5] == 'pred:toisto' or line[5] == 'pred') and not predj:
                            pred_toisto = True
                            if 'sg' in line[4]:
                                vseur_rivi[3] = 'sg'
                            elif 'pl' in line[4]:
                                vseur_rivi[3] = 'pl'
                            vseur_rivi[11] = n - taukoja
                            vseur_rivi[14] = line[2]
                            morf_kuvaukset[1] = line[4]
                            vseur_rivi[7] = line[1]
                            vseur_rivi[15] = line[2]
                            predj = False


                    vseur_rivi[6] = ' '.join(line[1] for line in ed_konteksti)
                    vseur_rivi[10] = ' '.join(line[1] for line in seur_konteksti)
                    vseur_rivi[18] = tuple(morf_kuvaukset)

                    fin_morf_kuv = str(morf_kuvaukset[1]).split()

                    if fin_morf_kuv[0] == 'fin':
                        if fin_morf_kuv[1] == 'ind':
                            vseur_rivi[17] = fin_morf_kuv[1] # eg. 'fin ind pres sg3'.split()[1] is the mood and (...).split()[2] is the tense
                            vseur_rivi[16] = fin_morf_kuv[2]
                        else:
                            vseur_rivi[17] = fin_morf_kuv[1] # esim. 'fin cond sg3'.split()[1] is the mood and the tense will stay None
                            vseur_rivi[16] = fin_morf_kuv[2] if fin_morf_kuv[2].isalpha() else None
                            if fin_morf_kuv[2].isalpha(): print(fin_morf_kuv)

                    vastaus.append(vseur_rivi)



    return vastaus
##tied_nimi = 'lam_antr.vrt'
##antr = etsi_tapaukset(tied_nimi)
suora = []
kaant = []
tapaus = 1
kapaus = 1 # käänteinen tapaus

def iidee(x):
    if x.endswith(',lam_ryma.vrt'):
        return 'rymrymrymrymrymrymrymrymrymrymry'
    else:
        return md5(x)


for tiedosto in tiedostot:
    nyk_murre = etsi_tapaukset(tiedosto)

    if not suora:
        for i, t in enumerate(nyk_murre):
            if i == 0:
                suora.append(['tapaus'] + t + ['tiedosto'])#, 'henk.id'])
                suora[-1].insert(-4, 'synt.vuosi')
                suora[-1].append('henk.id')
            else:
                suora.append([tapaus] + t + [tiedosto])
                suora[-1].insert(-4, suora[-1][-5][-4:])
                suora[-1].append(iidee(','.join([str(j) for j in suora[-1][-9:]])))
                tapaus += 1
    else:
        for t in nyk_murre[1:]:
            suora.append([tapaus] + t + [tiedosto])
            suora[-1].insert(-4, suora[-1][-5][-4:])
            suora[-1].append(iidee(','.join([str(j) for j in suora[-1][-9:]])))
            tapaus += 1

os.chdir(orig_folder)

write_table(suora, save_as)

