from collections import defaultdict
from collections import deque
import os
from csv_functions import avaa, write_table
from md5Hash import md5hash as md5

orig_folder = os.getcwd()

MAXSANVAL = 4 # maximum number of words+pauses
MAXDEPLENGTH = 4

save_as = 'substantiividataRajatonJulk.tsv'
save_as_knt = 'substantiividataRajatonJulk_knt.tsv'


os.chdir('korpus/LA-murre-vrt') # location of .vrt files



sukupuolet = defaultdict(lambda: '⚪')
#sukupuolet = {'male': '♂', 'female': '♀', None: '⚪'}
sukupuolet['male'] = '♂'
sukupuolet['female'] = '♀'

tiedostot = sorted([w for w in os.listdir() if w.endswith('.vrt')])

def laske_ika(pvm1, pvm2):
    try:
        paiva1, kuukausi1, vuosi1 = [int(i) for i in pvm1.split('.')]
        paiva2, kuukausi2, vuosi2 = [int(i) for i in pvm2.split('.')]

        ika = vuosi2-vuosi1

        if kuukausi1 > kuukausi2:
            ika -= 1
        elif kuukausi1 == kuukausi2 and paiva1 > paiva2:
            ika -= 1

        return ika
    except:
        return None

def etsi_tapaukset(tied_nimi):
    vrt_data = avaa(tied_nimi)
    rivit = vrt_data.splitlines()
    rivit.append('')
    
    vastaus = [['lnum', 'subst_lemma', 'kongr', 'ed_konteksti', 'subst_sm', 'verbi_sm', 'seur_konteksti', 'san.v.', 'verbi_lemma', 'morf', 'pitäjä', 'murreryhmä', 'murrealue', 'synt.aika', 'pvm', 'ikä', 'sp']]
    vastaus_knt = [['lnum', 'subst_lemma', 'kongr', 'ed_konteksti', 'verbi_sm', 'subst_sm', 'seur_konteksti', 'san.v.', 'verbi_lemma', 'morf', 'pitäjä', 'murreryhmä', 'murrealue', 'synt.aika', 'pvm', 'ikä', 'sp']]


    pit = None #parish (pitäjä)
    mr = None #dialect group (murreryhmä)
    ma = None #dialect region (murrealue)
    saik = None #birthdate
    pvm = None #date of recording
    ik = None #age
    sp = None #sex

    lid = None

    haast = False

    metadata_found = 0

    for n, line in enumerate(rivit[:-1]):
        if line.startswith('<text info='):
            if 'Äänitetty' in line:
                lstcheck = line[line.index('Äänitetty'):].split()
                for item in lstcheck:
                    rstripdot = item.rstrip('.')
                    if all(c.isdigit() or c == '.' for c in rstripdot):
                        pvm = rstripdot
                        metadata_found += 1
                        break
            if 'parish=' in line:
                pit = line[line.index('parish=')+8:].split('"')[0]
                metadata_found += 1
            if 'dialect_group=' in line:
                mr = line[line.index('dialect_group=')+15:].split('"')[0]
                metadata_found += 1
            if 'dialect_region=' in line:
                ma = line[line.index('dialect_region=')+16:].split('"')[0]
                metadata_found += 1

        if line.startswith('<'):
            if 'speaker_role=' in line and 'speaker_role="Speaker"' not in line: #lam_asko line 9489 starts <paragraph speaker_sex="" speaker_role=""
                haast = True
                continue
            elif 'speaker_role="Speaker"' in line:
                assert 'speaker_role="Interviewer"' not in line
                haast = False

            if 'speaker_birthdate=' in line:
                saik2 = '.'.join(line[line.index('speaker_birthdate=')+19:].split('"')[0].split('-')[::-1])
                if saik is None:
                    metadata_found += 1
                saik = saik2

            if 'speaker_age=' in line:
                ik2 = '.'.join(line[line.index('speaker_age=')+13:].split('"')[0].split('-')[::-1])

                if ik is None:
                    metadata_found += 1
                ik = ik2

            
            if 'speaker_sex=' in line:

                sp2 = sukupuolet[line[line.index('speaker_sex='):].split('=')[1].split()[0].strip('"')]
                if sp is None:
                    metadata_found += 1
                sp = sp2
            if line.startswith('<sentence') and not haast:
                try:
                    lid = line[line.rindex(' id=')+5:].split('"')[0]
                except:
                    lid = 'tuntematon' #unknown

                if not metadata_found >= 6:
                    print(n, line, tied_nimi, 'does not contain all metadata in expected places')
                    print(ik)
                    print(metadata_found, pit, mr, saik, pvm, sp)
                    metadata_found = 5
                    if ik is None:
                        ik = laske_ika(saik, pvm)
                
        elif not haast:
            
            solut = line.split('\t')
            seur_solut = rivit[n+1].split('\t')
            if not seur_solut or seur_solut[0].startswith('<'):
                continue
            ed_konteksti = deque()
            seur_konteksti = [seur_solut]

            m = n-1
            o = n+2

            while m >= 0 and not rivit[m].startswith('<'):
                ed_konteksti.appendleft(rivit[m].split('\t'))
                m -= 1

                


            try:

                while not rivit[o].startswith('<'):
                    seur_konteksti.append(rivit[o].split('\t'))
                    #print(rivit[o].startswith('<'), rivit[o])
                    o += 1

            except IndexError:
                #print(seur_konteksti)
                pass

            for line in list(ed_konteksti) + list(seur_konteksti):
                if line[5] in {'pred2', 'pred3'}:
                    contains_multiword_pred = True
                    break
            else: # solut[5] is always asked for in the "try", so this should work
                contains_multiword_pred = False

            #print(len(seur_konteksti))

            #vseur_rivi=[lnum,pron_lk,kongr,ed_konteksti,pron_sm,verbi_sm,seur_konteksti,sanoja_välissä,verbi_lemma,morf,pitäjä,murreryhmä,murrealue,synt.aika,pvm,ikä,sp]
            #vseur_rivi =[lid,None,   None, None,        None,   None,    None,          None,          None,       None,pit,   mr,        ma,       saik,     pvm,ik, sp]

            if not contains_multiword_pred:
                try:
                    if solut[3] == 'n' and 'pl nom' in solut[4] and solut[5] == 'npsubj':
                        for sanval, ssolut in enumerate(seur_konteksti):
                            vseur_rivi=[lid,None,None,None,None,None,None,None,None,None,pit,mr,ma,saik,pvm,ik,sp]
                            if ssolut[3] == 'v' and ssolut[5] == 'pred':
                                #if sanval > MAXSANVAL:
                                    #break
                                if 'pl3' in ssolut[4]:
                                    assert 'sg3' not in ssolut[4]
                                    vseur_rivi[2] = 'pl'
                                elif 'sg3' in ssolut[4]:
                                    assert 'pl3' not in ssolut[4]
                                    vseur_rivi[2] = 'sg'
                                vseur_rivi[1] = solut[2] # noun
                                vseur_rivi[4] = solut[1] # noun form
                                vseur_rivi[5] = ssolut[1] # verb form
                                vseur_rivi[8] = ssolut[2] # verb lemma
                                vseur_rivi[9] = ssolut[4] # verb morphological analysis

                                edkontlst = [j[1] for j in ed_konteksti]
                                seurkontlst = [j[1] for j in seur_konteksti]

                                vseur_rivi[3] = ' '.join(edkontlst) # previous context
                                vseur_rivi[6] = ' '.join(seurkontlst) # following context

                                vseur_rivi[7] = sanval # number of words in between

                                vseur_rivi[7] -= len([w for w in seurkontlst[:sanval] if set(w) == {'/'}])

                                wrong_npsubj = False # not allowed to have a nominal subject between the recognized subject and the predicate

                                for item in seur_konteksti[:sanval]:
                                    if item[5] == 'npsubj':
                                        wrong_npsubj = True
                                        break

                                #print(wrong_npsubj)
                                
                                #print(vseur_rivi[7])

                                #if not vseur_rivi[7] > MAXDEPLENGTH and not wrong_npsubj:
                                if not wrong_npsubj:   
                                    vastaus.append(vseur_rivi)
                                

                                #skip = sanval

                    #if solut[3] == 'n' and 'pl nom' in solut[4] and solut[5] == 'npsubj':
                    if solut[3] == 'v' and solut[5] == 'pred':
                        for sanval, ssolut in enumerate(seur_konteksti):
                            vseur_rivi=[lid,None,None,None,None,None,None,None,None,None,pit,mr,ma,saik,pvm,ik,sp]
                            #if ssolut[3] == 'v' and ssolut[5] == 'pred':
                            if ssolut[3] in {'n', 'n:prop'} and 'pl nom' in ssolut[4] and ssolut[5] == 'npsubj':
                                if 'pl3' in solut[4]:
                                    assert 'sg3' not in solut[4]
                                    vseur_rivi[2] = 'pl'
                                elif 'sg3' in solut[4]:
                                    assert 'pl3' not in solut[4]
                                    vseur_rivi[2] = 'sg'
                                vseur_rivi[1] = ssolut[2]# + ' / inverse' # noun
                                vseur_rivi[5] = ssolut[1] # noun form
                                vseur_rivi[4] = solut[1] # verb form
                                vseur_rivi[8] = solut[2] # verb lemma
                                vseur_rivi[9] = solut[4] # verb morphological analysis

                                edkontlst = [j[1] for j in ed_konteksti]
                                seurkontlst = [j[1] for j in seur_konteksti]

                                vseur_rivi[3] = ' '.join(edkontlst) # previous context
                                vseur_rivi[6] = ' '.join(seurkontlst) # following context

                                vseur_rivi[7] = sanval # words in between

                                vseur_rivi[7] -= len([w for w in seurkontlst[:sanval] if set(w) == {'/'}])

                                wrong_npsubj = False # not allowed to have a nominal subject between the recognized subject and the predicate

                                for item in seur_konteksti[:sanval]:
                                    if item[5] == 'npsubj':
                                        wrong_npsubj = True
                                        break

                                #print(wrong_npsubj)
                                
                                #print(vseur_rivi[7])

                                #if not vseur_rivi[7] > MAXDEPLENGTH and not wrong_npsubj:
                                if not wrong_npsubj:
                                    vastaus_knt.append(vseur_rivi)

                                
                    
                except IndexError:
                    pass

    return vastaus, vastaus_knt


suora = [] # direct
kaant = [] # inverse
tapaus = 1 # case
kapaus = 1 # inverse case

def iidee(x):
    if x.endswith(',lam_ryma.vrt'):
        return 'rymrymrymrymrymrymrymrymrymrymry'
    else:
        return md5(x)


for tiedosto in tiedostot:
    nyk_murre, nyk_murre_knt = etsi_tapaukset(tiedosto)
    if not suora:
        for i, t in enumerate(nyk_murre):
            if i == 0:
                suora.append(['tapaus'] + t + ['tiedosto'])#, 'henk.id'])
                suora[-1].insert(-4, 'synt.vuosi')
                suora[-1].append('henk.id')
            else:
                suora.append([tapaus] + t + [tiedosto])
                suora[-1].insert(-4, suora[-1][-5][-4:])
                suora[-1].append(iidee(','.join([str(j) for j in suora[-1][-9:]])))
                tapaus += 1
    else:
        for t in nyk_murre[1:]:
            suora.append([tapaus] + t + [tiedosto])
            suora[-1].insert(-4, suora[-1][-5][-4:])
            suora[-1].append(iidee(','.join([str(j) for j in suora[-1][-9:]])))
            tapaus += 1


    if not kaant:
        for i, t in enumerate(nyk_murre_knt):
            if i == 0:
                kaant.append(['tapaus'] + t + ['tiedosto'])#, 'henk.id'])
                kaant[-1].insert(-4, 'synt.vuosi')
                kaant[-1].append('henk.id')
            else:
                kaant.append([kapaus] + t + [tiedosto])
                kaant[-1].insert(-4, kaant[-1][-5][-4:])
                kaant[-1].append(iidee(','.join([str(j) for j in kaant[-1][-9:]])))
                kapaus += 1
    else:
        for t in nyk_murre_knt[1:]:
            kaant.append([kapaus] + t + [tiedosto])
            kaant[-1].insert(-4, kaant[-1][-5][-4:])
            kaant[-1].append(iidee(','.join([str(j) for j in kaant[-1][-9:]])))
            kapaus += 1

os.chdir(orig_folder)

write_table(suora, save_as)
write_table(kaant, save_as_knt)  
